/**
 * Um gravador video de disco rigido.
 *
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 *
 * @author Vasco T. Vasconcelos
 * @version 1.0 16/Set/2010 
 */
 
specification

  sorts
    GeneralVideoDisk

  constructors
    clear:  int -->? GeneralVideoDisk;
    record: GeneralVideoDisk Recording -->? GeneralVideoDisk;

  observers
    erase:         GeneralVideoDisk Recording --> GeneralVideoDisk;
    duration:      GeneralVideoDisk Recording --> int;
    title:         GeneralVideoDisk Recording --> String;
    capacity:      GeneralVideoDisk --> int;
    indexOf:       GeneralVideoDisk Recording --> int;
    isEmpty:       GeneralVideoDisk;
    lastIndex:     GeneralVideoDisk --> int;
    remainingTime: GeneralVideoDisk --> int;

  domains
    D: GeneralVideoDisk;
    I: int;
    R: Recording;

    clear(I)     if I >= 0;
    record(D, R) if remainingTime(D) >= durationR(R);

  axioms
    D: GeneralVideoDisk;
    S, T, R, U: Recording;
    I: int;

    // observers x constructors
    erase(record(D, R), U) = D when R = U else record(erase(D, U), R);

    duration(record(D, R), U) = durationR(R) when R = U else duration(D, U);

    title(record(D, R), U) = titleR(R) when R = U else title(D, U);

    capacity(clear(I)) = I;
    capacity(record(D, R)) = capacity(D);

    indexOf(clear(I), S) = -1;
    indexOf(record(D, R), T) = lastIndex(D) + 1 
                               when titleR(R) = titleR(T) else indexOf(D, T);

    isEmpty(clear(I));
    not isEmpty(record(D, R));

    lastIndex(clear(I)) = -1;
    lastIndex(record(D, R)) = 1 + lastIndex(D);

    remainingTime(clear(I)) = I;
    remainingTime(record(D, R)) = remainingTime(D) - durationR(R);

end specification
