/**
 * ADT specification for a recording session
 * A recording session specification  can be
 * defined in terms of
 *	record - creates an instance of this sort
 * 	title - name assigned to session
 *	duration - total recording's time
 *  isEmpty - checks if the session is empty
 *
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 *
 * @author Gloss
 * @version 1.0 16/Set/2010 
 */
specification

  sorts
    Recording

  constructors
    recordR: String int -->? Recording;

  observers
    titleR: Recording --> String;
    durationR: Recording --> int;

  others
    isEmptyR: Recording;

  domains
    t: String; d: int;
    recordR(t, d) if d >= 0;

  axioms
    r: Recording; 
    t: String; 
    d: int;

    // observers vs constructors
    titleR(recordR(t, d))    = t;
    
    durationR(recordR(t, d)) = d;

    // derived
    isEmptyR(r) iff durationR(r) = 0;

end specification
